# Stac_Dev



## Repo Purpose

Organize work around STAC catalog developments:
- ensure a consistent approach (across e.g. ESGF, EXPECT, DKRZ Catalog, Warmworld, Freva ..)
- data ingest tool(s) harmonization
- consistent aggregation sidecar files approach (kerchunk, virtualizar etc.)
- prototyping and production environment setups 
- cross catalog (meta-catalog) approach (metadata harmonization DestinE, Copernicus, etc.)
- client tooling and example notebooks

see also [Wiki](https://gitlab.dkrz.de/data-infrastructure-services/stac_dev/-/wikis/home)



## Coordination 

- See Canban board 


## get started

```
cd existing_repo
git remote add origin https://gitlab.dkrz.de/data-infrastructure-services/stac_dev.git
git branch -M main
git push -uf origin main
```

## Integrate with your tools

- [ ] [Set up project integrations](https://gitlab.dkrz.de/data-infrastructure-services/stac_dev/-/settings/integrations)

## Collaborate with your team

- [ ] [Invite team members and collaborators](https://docs.gitlab.com/ee/user/project/members/)
- [ ] [Create a new merge request](https://docs.gitlab.com/ee/user/project/merge_requests/creating_merge_requests.html)
- [ ] [Automatically close issues from merge requests](https://docs.gitlab.com/ee/user/project/issues/managing_issues.html#closing-issues-automatically)
- [ ] [Enable merge request approvals](https://docs.gitlab.com/ee/user/project/merge_requests/approvals/)
- [ ] [Set auto-merge](https://docs.gitlab.com/ee/user/project/merge_requests/merge_when_pipeline_succeeds.html)

## Test and Deploy

Use the built-in continuous integration in GitLab.

- [ ] [Get started with GitLab CI/CD](https://docs.gitlab.com/ee/ci/quick_start/index.html)
- [ ] [Analyze your code for known vulnerabilities with Static Application Security Testing (SAST)](https://docs.gitlab.com/ee/user/application_security/sast/)
- [ ] [Deploy to Kubernetes, Amazon EC2, or Amazon ECS using Auto Deploy](https://docs.gitlab.com/ee/topics/autodevops/requirements.html)
- [ ] [Use pull-based deployments for improved Kubernetes management](https://docs.gitlab.com/ee/user/clusters/agent/)
- [ ] [Set up protected environments](https://docs.gitlab.com/ee/ci/environments/protected_environments.html)

***
