from src.create_with_eeriecloud import *
from pystac_client import Client as psc
from utils.defaults import *
from utils.api_interaction import *

import datetime
dnow=datetime.datetime.now()
end=dnow.strftime("%Y")
    
L_DELETE=True

STAC_COLLECTION_CONF=dict(
    project_id="ERA",
    activity_id="ERA5",
    start="1940",
    end=end,
    description_key="title"
    #institution_id=None,
    #source_id=None
)

stac_collection_id_raw=get_collection_id_from_item(
    STAC_COLLECTION_CONF,
    template_item=None # this uses eerie cloud as default
)

print(stac_collection_id_raw)
stac_collection_id=stac_collection_id_raw.replace('<','').replace('>','')

print(stac_collection_id)

cat=psc.open(
    defaults["STAC_BASE_URL"]
)
if L_DELETE:
    xp_exps=list(cat.get_all_collections())
    print("Delete collections")
    for xp_exp in xp_exps:
        if xp_exp.id.startswith("ERA"):
            api_delete_collection(defaults["STAC_BASE_URL"],xp_exp.id)

print("Create new collection from eerie cloud")
collection=create_collection_from_eerieclouditem(
    STAC_COLLECTION_CONF,
    stac_collection_id_raw
)

print("Ingest new collection")
api_create_or_update_collection(
    defaults["STAC_BASE_URL"],
    stac_collection_id,
    collection
)

print("Create items")
items=create_items_from_eeriecloud(
    STAC_COLLECTION_CONF["project_id"],
    stac_collection_id
)

print("Ingest items")
for item in items:    
    try:
        api_create_or_update_item(
            defaults["STAC_BASE_URL"],
            stac_collection_id,
            item
        )
    except Exception as e:
        print(item["id"])
        print(e)